MixedContentModel (Xerces2 Implementation)
Date: 2018-10-17

org.apache.xerces.impl.dtd.models

## Class MixedContentModel

- java.lang.Object
- - org.apache.xerces.impl.dtd.models.MixedContentModel

- All Implemented Interfaces:
    ContentModelValidator

      public class MixedContentModel
      extends java.lang.Object
      implements ContentModelValidator

  MixedContentModel is a derivative of the abstract content model base class that handles the special case of mixed model elements. If an element is mixed model, it has PCDATA as its first possible content, followed by an alternation of the possible children. The children cannot have any numeration or order, so it must look like this:

         <!ELEMENT Foo ((#PCDATA|a|b|c|)*)>

  So, all we have to do is to keep an array of the possible children and validate by just looking up each child being validated by looking it up in the list.
  Version:
    $Id: MixedContentModel.java 699892 2008-09-28 21:08:27Z mrglavas $

  # INTERNAL:

    Usage of this class is not supported. It may be altered or removed at any time.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `MixedContentModel(org.apache.xerces.xni.QName[] children, int[] type, int offset, int length, boolean ordered)` Constructs a mixed content model.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `validate(org.apache.xerces.xni.QName[] children, int offset, int length)` Check that the specified content is valid according to this content model.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### MixedContentModel

          public MixedContentModel(org.apache.xerces.xni.QName[] children,
                                   int[] type,
                                   int offset,
                                   int length,
                                   boolean ordered)

      Constructs a mixed content model.
      Parameters:
        `children` - The list of allowed children.
        `type` - The list of the types of the children.
        `offset` - The start offset position in the children.
        `length` - The child count.
        `ordered` - True if content must be ordered.

  - ### Method Detail

    - #### validate

          public int validate(org.apache.xerces.xni.QName[] children,
                              int offset,
                              int length)

      Check that the specified content is valid according to this content model. This method can also be called to do 'what if' testing of content models just to see if they would be valid.

      A value of -1 in the children array indicates a PCDATA node. All other indexes will be positive and represent child elements. The count can be zero, since some elements have the EMPTY content model and that must be confirmed.

      Specified by:
        `validate` in interface `ContentModelValidator`
      Parameters:
        `children` - The children of this element. Each integer is an index within the `StringPool` of the child element name. An index of -1 is used to indicate an occurrence of non-whitespace character data.
        `offset` - Offset into the array where the children starts.
        `length` - The number of entries in the `children` array.
      Returns:
        The value -1 if fully valid, else the 0 based index of the child that first failed. If the value returned is equal to the number of children, then the specified children are valid but additional content is required to reach a valid ending state.

Copyright © 1999-2010 The Apache Software Foundation. All Rights Reserved.